/* Smtpsend --- Smtp Mail Sender html version */
/* 2000/02/16 Ver.1.x */
/* Programmer K.Mori(COW) */
/* GNU General Public Licence */
/* You must make html page by JIS code. */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>

int smtpcheck(char strs[]);
void convertstr(char strs[]);

/* global value */
char buff[65000];

extern int errno;

int main(argc, argv)
int argc;
char **argv;
{
  char c;
  FILE *fp;
  char ch[65000],hostname[64],fromname[64],toname[64],subject[64],texts[65000],rstrs[256],sstrs[65000];
  char l[64],opt[3],version[10]={"1.2.0"};
  char pare1[65000],pare2[65000],pare3[65000],pare4[65000],pare5[65000];
  char name1[64],name2[64],name3[64],name4[64],name5[64];
  char valu1[65000],valu2[65000],valu3[65000],valu4[65000],valu5[65000];
  register long int i,s;
  long int len, j, k;
  struct hostent *hp;
  struct sockaddr_in sin;

  strcpy(ch,getenv("CONTENT_LENGTH"));
  sscanf(ch,"%d",&len);
  len++;
  fgets(ch,len,stdin);
  for(i=0;len>i;i++) {
    if(ch[i]=='&') ch[i]=' ';
  }
  sscanf(ch,"%s %s %s %s %s", &pare1, &pare2, &pare3, &pare4, &pare5);
  for(i=0;strlen(pare1)>i;i++) {
    if(pare1[i]=='=') pare1[i]=' ';
  }
  sscanf(pare1,"%s %s", &name1 ,&valu1);
  for(i=0;strlen(pare2)>i;i++) {
    if(pare2[i]=='=') pare2[i]=' ';
  }
  sscanf(pare2,"%s %s", &name2 ,&valu2);
  for(i=0;strlen(pare3)>i;i++) {
    if(pare3[i]=='=') pare3[i]=' ';
  }
  sscanf(pare3,"%s %s", &name3 ,&valu3);
  for(i=0;strlen(pare4)>i;i++) {
    if(pare4[i]=='=') pare4[i]=' ';
  }
  sscanf(pare4,"%s %s", &name4 ,&valu4);
  for(i=0;strlen(pare5)>i;i++) {
    if(pare5[i]=='=') pare5[i]=' ';
  }
  sscanf(pare5,"%s %s", &name5 ,&valu5);
  if(0 == strcmp(name1,"HOST")) strcpy(hostname,valu1);
  if(0 == strcmp(name2,"HOST")) strcpy(hostname,valu2);
  if(0 == strcmp(name3,"HOST")) strcpy(hostname,valu3);
  if(0 == strcmp(name4,"HOST")) strcpy(hostname,valu4);
  if(0 == strcmp(name5,"HOST")) strcpy(hostname,valu5);
  convertstr(hostname);
  strcpy(hostname,buff);
  if(0 == strcmp(name1,"FROMAD")) strcpy(fromname,valu1);
  if(0 == strcmp(name2,"FROMAD")) strcpy(fromname,valu2);
  if(0 == strcmp(name3,"FROMAD")) strcpy(fromname,valu3);
  if(0 == strcmp(name4,"FROMAD")) strcpy(fromname,valu4);
  if(0 == strcmp(name5,"FROMAD")) strcpy(fromname,valu5);
  convertstr(fromname);
  strcpy(fromname,buff);
  if(0 == strcmp(name1,"TOAD")) strcpy(toname,valu1);
  if(0 == strcmp(name2,"TOAD")) strcpy(toname,valu2);
  if(0 == strcmp(name3,"TOAD")) strcpy(toname,valu3);
  if(0 == strcmp(name4,"TOAD")) strcpy(toname,valu4);
  if(0 == strcmp(name5,"TOAD")) strcpy(toname,valu5);
  convertstr(toname);
  strcpy(toname,buff);
  if(0 == strcmp(name1,"SUBJECT")) strcpy(subject,valu1);
  if(0 == strcmp(name2,"SUBJECT")) strcpy(subject,valu2);
  if(0 == strcmp(name3,"SUBJECT")) strcpy(subject,valu3);
  if(0 == strcmp(name4,"SUBJECT")) strcpy(subject,valu4);
  if(0 == strcmp(name5,"SUBJECT")) strcpy(subject,valu5);
  convertstr(subject);
  strcpy(subject,buff);
  if(0 == strcmp(name1,"TEXTS")) strcpy(texts,valu1);
  if(0 == strcmp(name2,"TEXTS")) strcpy(texts,valu2);
  if(0 == strcmp(name3,"TEXTS")) strcpy(texts,valu3);
  if(0 == strcmp(name4,"TEXTS")) strcpy(texts,valu4);
  if(0 == strcmp(name5,"TEXTS")) strcpy(texts,valu5);
  convertstr(texts);
  strcpy(texts,buff);

  /* print version */
  printf("Content-type: text/html\n\n<html>\n<head><title>"
	 "smtpsendh result</title></head>\n<body>"
	 "<h2>-%s- Smtp mail Sender(html).Ver.%s Copyright 2000(C)COW</h2>"
	 "<br><hr>\n",argv[0],version);

  /* lookup the network address */
  if ((hp = gethostbyname(hostname)) == NULL) {
    fprintf(stderr, "%s: unknown host.\n", hostname);
    exit(-1);
  }

  /* get a socket to work with. */
  if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    fprintf(stderr,"client: socket error.\n");
    exit(-1);
  }

   /* create the address we will be connecting to. */
  /* use smtp port 25 */
  sin.sin_family = AF_INET;
  sin.sin_port = htons(25);
  bcopy(hp->h_addr, &sin.sin_addr, hp->h_length);
  /* try to connect to the address. */
  if (connect(s, &sin, sizeof(sin)) < 0) {
    fprintf(stderr,"client: connect error.\n");
    exit(-1);
  }

  /* open reading the socket. */
  fp = fdopen(s, "r");

  /* first read some strings. */
  fgets(rstrs, 2048, fp);
  if (smtpcheck(rstrs)) exit(-1);

  /* send fromname */
  strcpy(sstrs,"HELO ");
  strcat(sstrs,hostname);
  strcat(sstrs,"\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  printf("\nConnect to:%s<br>\n",hostname);

  /* read response */
  fgets(rstrs, 2048, fp);
  if (smtpcheck(rstrs)) exit(-1);

  /* send fromname */
  strcpy(sstrs,"MAIL FROM:<");
  strcat(sstrs,fromname);
  strcat(sstrs,">\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  printf("\nMail from:%s<br>\n",fromname);

  /* read response */
  fgets(rstrs, 2048, fp);
  if (smtpcheck(rstrs)) exit(-1);

  /* send toname */
  strcpy(sstrs,"RCPT TO:<");
  strcat(sstrs,toname);
  strcat(sstrs,">\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  printf("\nMail to:%s<br>\n",toname);

  /* read response */
  fgets(rstrs, 2048, fp);
  if (smtpcheck(rstrs)) exit(-1);

  /* put message ready */
  strcpy(sstrs,"DATA\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  printf("\n---%s Start---<br>\n",sstrs);

  /* read response */
  fgets(rstrs, 2048, fp);
  if (smtpcheck(rstrs)) exit(-1);

  /* put message */
  strcpy(sstrs,"From:");
  strcat(sstrs,fromname);
  strcat(sstrs,"\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  strcpy(sstrs,"To:");
  strcat(sstrs,toname);
  strcat(sstrs,"\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  strcpy(sstrs,"X-Mailer:smtpsendh ");
  strcat(sstrs,version);
  strcat(sstrs,"\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  printf("\n%s<br>\n",sstrs);
  strcpy(sstrs,"Subject:");
  strcat(sstrs,subject);
  strcat(sstrs,"\r\n\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  printf("\n%s<br><hr>\n",sstrs);

  j = 0; k = 0; sstrs[0] = 0;
  while (texts[j] != 0) {
    if((texts[j] == 0x0A)||(texts[j] == 0x0D)){
      sstrs[k++] = 0;
      j++;
      if((texts[j] == 0x0A)||(texts[j] == 0x0D)){
	sstrs[k] = 0;
	j++;
      }
      printf("\n%s<br>\n",sstrs);
      strcat(sstrs,"\r\n");
      send(s,sstrs,strlen(sstrs),0);
      k = 0; sstrs[0] = 0;
    } else {
      sstrs[k++] = texts[j++];
    }
  }
  if( k > 0){
    sstrs[k] = 0;
    printf("\n%s<br>\n",sstrs);
    strcat(sstrs,"\r\n");
    send(s,sstrs,strlen(sstrs),0);
  }

  /*  strcpy(sstrs,texts);
  send(s,sstrs,strlen(sstrs), 0);
  printf("\n%s<br>\n",sstrs);*/

  /* put message end */
  strcpy(sstrs,"\r\n.\r\n");
  send(s,sstrs,strlen(sstrs), 0);

  /* read response */
  fgets(rstrs, 2048, fp);
  if (smtpcheck(rstrs)) exit(-1);

  /* quit smtp server*/
  strcpy(sstrs,"QUIT\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  
  /* read response */
  fgets(rstrs, 2048, fp);
  if (smtpcheck(rstrs)) exit(-1);

  printf("\n<br><hr>---Message Send.---</body></html>\n");

  close(s);
  fclose(fp);

  exit(0);
}

int smtpcheck(strs)
char strs[];
{
  if((strs[0] == '2')||(strs[0] == '3')) return 0;
  else {
    fprintf(stderr,"-ERROR Stop\n");
    return -1;
  }
}

void convertstr(strs)
char strs[];
{
  unsigned int i,j,h;
  char hexx[3];

  i = 0; j = 0;h = 0;buff[0]=0;
  while(strs[i] != 0) {
    if ('%' == strs[i]){
      i++;
      hexx[0]=strs[i++];hexx[1]=strs[i++];hexx[2]=0;
      sscanf(hexx,"%x",&h);
      buff[j++] = h;
    } else {
      if('+' == strs[i]) {
	i++; buff[j++] = ' ';
      } else buff[j++] = strs[i++];
    }
  }
  buff[j] = 0;
}

